# PANEL A: ATTENTION
library(feather)
df <- read_feather("/home/thom/Dropbox/Partners/Adham_Thom/LumAB/Gobp_test_attention_df.feather")
df <- as.data.frame(df)
dim(df)
head(df)
df[1:5,1:5]
colnames(df)
tail(colnames(df))
tail(rownames(df))
df.go <- df[,grepl("GO:", colnames(df))]
vars <- apply(df.go, 2, var)
vars <- sort(vars, decreasing = TRUE)
plot(vars)
keep <- names(vars[1:5])
x <- prcomp(df.go)
library(ggbiplot)
g1 <- ggbiplot(x, groups = factor(ifelse(df$true, "LumA", "LumB")), scale = 1, varname.size = 6,
               labels.subset = keep, labels.col = "black", circle = FALSE, ellipse = FALSE) +
  scale_color_manual(values=c("#FDE725FF", "#21908CFF")) + # viridis-esque
  theme_bw() +
  theme(text = element_text(size=18),
        plot.title = element_text(size=24)) + labs(col = "Sub-type") +
  ggtitle("A") + guides(col = FALSE) + labs(subtitle = "PCA Biplot of Importance Scores")

# PANEL B: NON-ATTENTION
library(feather)
df <- read_feather("/home/thom/Dropbox/Partners/Adham_Thom/LumAB/GObp_test_pathways_df.feather")
df <- as.data.frame(df)
dim(df)
head(df)
df[1:5,1:5]
colnames(df)
tail(colnames(df))
tail(rownames(df))
df.go <- df[,grepl("GO:", colnames(df))]
vars <- apply(df.go, 2, var)
vars <- sort(vars, decreasing = TRUE)
plot(vars)
keep <- names(vars[1:5])
x <- prcomp(df.go)
library(ggbiplot)
g2 <- ggbiplot(x, groups = factor(df$PAM50), scale = 1, varname.size = 6,
               labels.subset = keep, labels.col = "black", circle = FALSE, ellipse = FALSE) +
  scale_color_manual(values=c("#FDE725FF", "#21908CFF")) + # viridis-esque
  theme_bw() +
  theme(text = element_text(size=18),
        plot.title = element_text(size=24)) + labs(col = "Sub-type") +
  ggtitle("B") + labs(subtitle = "PCA Biplot of Annotation Features")

library(patchwork)
gg <- g1 + g2

ggsave("/home/thom/Dropbox/Partners/Adham_Thom/LumAB/1-GoWeights.pdf", gg,
       scale = 2.5, dpi = 600, width = 6, height = 4)
