annot <- read.csv("/home/thom/Dropbox/Partners/Adham_Thom/LumAB-Annot/TCGA-BRCA-phenotypes.csv",
                  stringsAsFactors = FALSE)
test <- read.csv("/home/thom/Dropbox/Partners/Adham_Thom/LumAB-Annot/test_idxs.csv",
                 stringsAsFactors = FALSE, header = FALSE)

all(test[,1] %in% annot$barcode)#OK

rownames(annot) <- annot$barcode
all(test[,1] %in% rownames(annot))
TEST <- annot[test[,1],]
table(TEST$subtype_Tumor, TEST$tumor_stage, exclude = FALSE)
TEST$new_stage <- gsub("(ia)|(ib)|(ic)", "i", TEST$tumor_stage)
TEST$new_stage[is.na(TEST$new_stage) | TEST$new_stage == "not reported"] <- "unavailable"
table(TEST$new_stage)

# SUBTYPES
Z <- TEST[,c(#"subtype_Gender",#"subtype_Age.at.Initial.Pathologic.Diagnosis",
  "subtype_ER.Status", "subtype_PR.Status", "subtype_HER2.Final.Status",
  "subtype_Tumor", "subtype_Node", "subtype_Metastasis",
  "new_stage", "tumor_stage", "days_to_death", "race")]
Z$subtype_ER.Status[Z$subtype_ER.Status == "Not Performed"]<-NA
Z$subtype_PR.Status[Z$subtype_PR.Status %in% c("Indeterminate", "Not Performed")]<-NA
Z$subtype_HER2.Final.Status[Z$subtype_HER2.Final.Status %in% c("Equivocal", "Not Available")]<-NA
Z$subtype_Tumor[Z$subtype_Tumor == "TX"]<-NA
apply(Z, 2, table)

# GET PC FROM ATTENDED GO
library(feather)
df <- read_feather("/home/thom/Dropbox/Partners/Adham_Thom/LumAB/Gobp_test_attention_df.feather")
df <- as.data.frame(df)
dim(df)
head(df)
df[1:5,1:5]
colnames(df)
tail(colnames(df))
tail(rownames(df))
df.go <- df[,grepl("GO:", colnames(df))]
vars <- apply(df.go, 2, var)
vars <- sort(vars, decreasing = TRUE)
plot(vars)
keep <- names(vars[1:5])
x <- prcomp(df.go)

# SUBSET LumA ONLY
Z <- Z[df$predict == 1,]
x$x <- x$x[df$predict == 1,]

# LM POST-HOC
TNM <- Z[,c("subtype_Tumor", "subtype_Node", "subtype_Metastasis")]
# TNM[,1] <- as.numeric(factor(TNM[,1]))
# TNM[,2] <- as.numeric(factor(TNM[,2]))
# TNM[,3] <- as.numeric(factor(TNM[,3]))
TNM$pc <- x$x[,1]
summary(lm(pc~ . + 0, TNM))
TNM$pc <- x$x[,2]
summary(lm(pc~ . + 0, TNM))

# # Visualize
# boxplot(pc~subtype_Tumor,Z, ylab = "Second PCA Axis of GO Importance Scores")
# boxplot(pc~new_stage,Z, ylab = "Second PCA Axis of GO Importance Scores")
# library(ggplot2)
# df.plot <- Z[,c("subtype_Tumor", "race", "pc", "new_stage", "tumor_stage")]
# df.plot$subtype_Tumor[is.na(df.plot$subtype_Tumor)] <- "Unknown"
# df.plot$subtype_Tumor <- factor(df.plot$subtype_Tumor, levels = c("Unknown", "T1","T2", "T3", "T4"))
# # df.plot$new_stage[df.plot$new_stage %in% c("stage i", "stage ii", "stage iii")] <- "Stage I-III"
# # df.plot$new_stage[df.plot$new_stage %in% c("stage iv", "stage x")] <- "Stage II-V"
# df.plot$tumor_stage[is.na(df.plot$tumor_stage) | df.plot$tumor_stage == "not reported"] <- "not available"
# df.plot$tumor_stage <- factor(df.plot$tumor_stage)
# library(ggbeeswarm)
# g3 <- ggplot(df.plot, aes(x = subtype_Tumor, y = pc)) + geom_point() +
#   xlab("Tumour grade") + ylab("Second PCA axis of GO importance scores") +
#   #ggtitle("C") +
#   theme_bw() +
#   theme(text = element_text(size=18),
#         plot.title = element_text(size=24)) + 
#   labs(subtitle = "Luminal A intra-class variance across GO importance scores")
# 
# plot(g3)
# 
# ggsave("/home/thom/Dropbox/Partners/Adham_Thom/LumAB-Annot/PCA-follow-up.pdf", g3,
#        scale = 2, dpi = 600, width = 6, height = 4)
