library(feather)
H <- read_feather("/home/thom/Dropbox/Partners/Adham_Thom/LumAB-NMF/genes_test_H.feather")
W <- read_feather("/home/thom/Dropbox/Partners/Adham_Thom/LumAB-NMF/genes_test_W.feather")
H <- as.data.frame(H)
W <- as.data.frame(W)

H[1:5,1:5]
W[1:5,1:5]

colnames(H)[apply(H, 1, which.max)]

library(ggplot2)
colnames(W)[1:7] <- paste0("f", 1:7)
g1 <- ggplot(W, aes(col = PAM50, y = f1)) + geom_boxplot() +
  scale_color_manual(values=c("#FDE725FF", "#21908CFF")) + # viridis-esque
  labs(col = "Group") + theme_bw() + labs(col = "Sub-type") +
  ylab("Factor score") + xlab("Cancer Sub-type") +
  ggtitle("B") +
  theme(text = element_text(size=18),
        plot.title = element_text(size=24)) +
  theme(axis.text.x=element_blank()) + labs(subtitle = "Distribution of Samples")

Hdf <- as.data.frame(t(H[1,]))
Hdf$ID <- rownames(Hdf)
Hdf$Number <- 1:nrow(Hdf)
colnames(Hdf)[1] <- "f1"
Hdf$f1 <- Hdf$f1 / sum(Hdf$f1)
head(Hdf)
library(ggrepel)
g2 <- ggplot(Hdf, aes(x = Number, y = f1)) + geom_line() +
  theme_bw() + ylab("Relative contribution to factor") + xlab("Gene term") +
  geom_label_repel(aes(label = ID), data = Hdf[Hdf$f1 > .02, ], direction = "y") +
  ggtitle("A") +
  theme(text = element_text(size=18),
        plot.title = element_text(size=24)) +
  theme(axis.text.x=element_blank()) + labs(subtitle = "Contribution of Features to Factor")

gg <- egg::ggarrange(g2, g1, widths = 2:1)

ggsave("/home/thom/Dropbox/Partners/Adham_Thom/LumAB-NMF/genes_NMF_plot.pdf", gg,
       scale = 2, dpi = 600, width = 6, height = 4)
